/* Copyright (C) 2002-2003, OpenOSX(TM), ALL RIGHTS RESERVED.
   This digital file is free software; OpenOSX(TM)
   gives unlimited permission to copy and/or distribute it,
   with or without modifications, as long as this notice is preserved.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY, to the extent permitted by law; without
   even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.
*/

#include <Carbon/Carbon.h>

void Abort(const char *err)
{
  fprintf(stderr, "Usage: launchURL url\n\n%s\n", err);
  exit(1);
}

int main (int argc, const char * argv[]) {
    ICInstance gICInstance = NULL; 
    OSStatus err;
    long selectionBegin, selectionEnd;

    //printf ("argc %i", argc);

    printf ("\nOpenOSX launchURL 1.0\n\n");
    printf ("This digital file is free software; OpenOSX(TM)\n");
    printf ("gives unlimited permission to copy and/or distribute it,\n");
    printf ("with or without modifications, as long as this notice is preserved.\n\n");

    printf ("This program is distributed in the hope that it will be useful,\n");
    printf ("but WITHOUT ANY WARRANTY, to the extent permitted by law; without\n");
    printf ("even the implied warranty of MERCHANTABILITY or FITNESS FOR A\n");
    printf ("PARTICULAR PURPOSE.\n\n");

    if (argc != 2) {
      Abort(argv[1]);
    }

    err = ICStart(&gICInstance, 'Ourl');
    if (err != noErr) {
        Abort("launchURL: InternetConfig Error, please double-check your Internet System Preference and try again.");
    }

    selectionBegin = 0;
    selectionEnd = strlen(argv[1]);
    err = ICLaunchURL(gICInstance, "", argv[1], selectionEnd, &selectionBegin, &selectionEnd);
    if (err != noErr) {
        Abort(argv[1]);
     }

    err = ICStop(gICInstance);
    if (err != noErr) {
        Abort("launchURL: An InternetConfig \"Close Error\" Has Occured");
    }

    return 0;
}
